#include <iostream>
#include <bits/stdc++.h>
using namespace std;
const int maxN=8e4+5;
long long a[maxN];
long long b[maxN];
long long nzd(long long a,long long b)
{
    if(b==0)
        return a;
    return nzd(b,a%b);
}
bool check(long long val,long long T,int n)
{
    int l=1;
    int r=n;
    if(val<a[1])
    {
        if((a[1]-val)%T==0)
            return 0;
    }
    if(val>a[n])
    {
        if((val-a[n])%T==0)
            return 0;
    }
    while(l<r-1)
    {
        int mid=(l+r)/2;
        if(val>a[mid])
        {
            l=mid;
        }
        else{
            r=mid;
        }
    }
    if((val-a[l])%T==0)
        return 0;
    return 1;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    //ifstream cin("C:/Users/zoran/Desktop/drvo.txt");
    int t;
    int n,m;
    cin>>t;
    while(t--)
    {
        cin>>n>>m;
        for(int i=1;i<=n;i++)
        {
            cin>>a[i];
        }
        for(int i=1;i<=m;i++)
        {
            cin>>b[i];
        }
        sort(a+1,a+n+1);
        sort(b+1,b+m+1);
        long long T=a[2]-a[1];
        for(int i=3;i<=n;i++)
        {
            T=nzd(T,a[i]-a[i-1]);
        }
        if(T==1)
        {
            cout<<"0\n";
        }
        else{
            bool imar=1;
            for(int i=1;i<=m;i++)
            {
                if(!check(b[i],T,n))
                {
                    cout<<"0\n";
                    imar=0;
                    break;
                }
            }
            if(imar)
            {
                cout<<"1\n";
            }
        }
    }
    return 0;
}